%define anolis_release 2

Name:           keentune-target
Version:        3.1.0
Release:        %{?anolis_release}%{?dist}
Summary:        Parameters setting, reading and backup models for KeenTune
Vendor:         Alibaba
License:        MulanPSLv2
Group:          Development/Languages/Python
Source0:        https://gitee.com/anolis/keentune_target/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BUildRequires:	systemd
BuildArch:      noarch

Requires:       python3-tornado, python3-pyudev, python3-requests
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
Parameters setting, reading and backup models for KeenTune

%prep
%autosetup -n keentune_target-v%{version}

%build
%{__python3} setup.py build

%install
%{__python3} setup.py install --single-version-externally-managed -O1 --prefix=%{_prefix} --root=%{buildroot} --record=INSTALLED_FILES
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/systemd/system/
cp -f ./keentune-target.service ${RPM_BUILD_ROOT}/usr/lib/systemd/system/
install -D -m 0644 man/keentune-target.domain.7 ${RPM_BUILD_ROOT}%{_mandir}/man7/keentune-target.domain.7
install -D -m 0644 man/keentune-target.8 ${RPM_BUILD_ROOT}%{_mandir}/man8/keentune-target.8
install -D -m 0644 man/keentune-target.conf.5 ${RPM_BUILD_ROOT}%{_mandir}/man5/keentune-target.conf.5

%clean
rm -rf $RPM_BUILD_ROOT

%post
%systemd_post keentune-target.service
if [ -f "%{_prefix}/lib/systemd/system/keentune-target.service" ]; then
    systemctl enable keentune-target.service || :
    systemctl start keentune-target.service || :
fi

%preun
%systemd_preun keentune-target.service

%postun
%systemd_postun keentune-target.service

%files -f INSTALLED_FILES
%defattr(-,root,root)
%license LICENSE
%{_prefix}/lib/systemd/system/keentune-target.service
%{_mandir}/man7/keentune-target.domain.7*
%{_mandir}/man8/keentune-target.8*
%{_mandir}/man5/keentune-target.conf.5*

%changelog
* Wed Oct 16 2024 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 3.1.0-2
- default startup keentune-target

* Wed Sep 25 2024 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 3.1.0-1
- code refactor
- add simple param white list for target security
- fix: remove XPS, RPS from mysql.conf
- modify default loglevel of target to ERROR
- fix: not remove runing data and install dir

* Thu Mar 14 2024 Bo Ren <rb01097748@alibaba-inc.com> - 2.3.1-3
- Rebuild with python3.11

* Tue Jan 02 2023 happy_orange <songnannan@linux.alibaba.com> - 2.3.1-2
- fix the version number

* Thu Dec 28 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.3.1-1
- An official version merged all 2.3.0-* release version

* Wed Sep 20 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.3.0-2
- erdma: smc: fix kernel version dependency and memory configure
- fix: incorrectly setting value of rps_flow_cnt to rps_cpus
- fix: check empty value before sysctl -n

* Thu Sep 14 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.3.0-1
- add x264_265 feature

* Thu Jul 13 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-12
- remove value set in spectre_bhb

* Wed Jul 12 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-11
- fix: can not rollback affinity
- add grub recommandation

* Tue Jul 11 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-10
- remove /var/keentune/lib when uninstall
- add 'all' schema for RPS/XPS
- rollback affinity 'eighth' bug fix
- remove /rps_cpus setting in RFS

* Tue Jul 11 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-9
- fix: rps & xps 'different' binding schema
- feat: add glub domain
- fix: affinity 'eighth' binding schema

* Mon Jul 10 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-8
- fix: can not read cpu range of numa when process = 1 or 2

* Fri Jul 7 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-7
- fix: rename gzip to zlib and remove rpm name in gzip
- nginx: add gzip setting

* Wed Jul 5 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-6
- update gzip version to 20230705141537

* Wed Jul 5 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-5
- add file domain for KS

* Wed Jul 5 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-4
- remove gzip rpm
- set affinity by script

* Mon Jul 3 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-3
- fix bug: affinity binding schema error when processor is 8

* Thu Jun 29 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-2
- fix: RFS: Value too large for defined data type
- auto setting script of xps/rps

* Mon Jun 26 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.2.0-1
- feature-level & domain-level defination of knobs

* Tue Apr 25 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.1.0-5
- fix: backup all error in mycnf and nginx conf
- fix: xps/rps and smp_affinity rollback error

* Fri Apr 21 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.1.0-4
- add unit test case

* Mon Feb 27 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.1.0-3
- fix low dependency version
- fix additional fd occupation bug

* Mon Feb 27 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.1.0-1
- load domain by /init api
- no more init domain and backup value aftr target starts
- running parameter reading and setting in subprocess
- add /terminate api to kill reading or setting subprocess

* Mon Jan 16 2023 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.0.1-2
- modify default domain to sysctl, net
- add requires of 'pyudev'
- remove disk config param 'apm' and 'spindown'

* Thu Dec 15 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.0.1-1
- disable backup all and rollback all in this version
- modify xps/rps code of param value 'different'
- init partial domain when target start

* Thu Dec 15 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 2.0.0-0
- add tuned domain
- add basic domain class 
- add basic benchmark domain class
- modify installation directory

* Mon Oct 31 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.4.0-1
- fix: domain 'my_cnf' actived without mysql sevice
- fix: fix the problem that cannot be rolled back normally

* Mon Oct 17 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.3.3-1
- fix: interrupts bonding because of virtio2/virtio3
- fix: service type to 'forking' from 'simple'

* Thu Jul 21 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.3.2-0
- fix some bugs

* Thu Jul 21 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.3.0-1
- fix: missing of man dir  

* Thu Jun 30 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.3.0-0
- rename target to agent
- add RESTful API /available
- refactor original configuration backup

* Mon Jun 20 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.2.1-1
- update docs
- fix bug: tuning stoped because of serival knobs setting failed.

* Mon Apr 04 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.2.0-2
- Wrong version index in python
- Control checking range of settable target for 'profile set'
- add function of all rollback

* Thu Mar 03 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.1.0-2
- fix bug: update version to 1.1.0 in setup.py script.

* Thu Mar 03 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.1.0-1
- Add support for GP (in iTuned) in sensitizing algorithms
- Add support for lasso in sensitizing algorithms
- refactor tornado module: replace await by threadpool
- lazy load domain in keentune-target
- fix other bugs

* Sat Jan 01 2022 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.1-1
- Verify input arguments of command 'param tune'
- Supporting of multiple target tuning
- Fix bug which cause keentune hanging after command 'param stop'
- Add verification of conflicting commands such as 'param dump', 'param delete' when a tuning job is runing.
- Remove version limitation of tornado
- Refactor sysctl domain to improve stability of parameter setting
- Fix some user experience issues

* Sun Dec 12 2021 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.0-5
- fix bug: can not running in alinux2 and centos7
- change modify codeup address to gitee

* Wed Dec 01 2021 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.0-4
- add keentune to systemd

* Wed Nov 24 2021 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.0-3
- fix: wrong license in setup.py
- add nginx conf parameter domain

* Wed Nov 10 2021 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.0-2
- use '%license' macro
- update license to MulanPSLv2

* Wed Aug 18 2021 Runzhe Wang <runzhe.wrz@alibaba-inc.com> - 1.0.0-1
- Initial KeenTune-target
